/******************************************************************************/
// Dungeon Keeper 2 Textures Tool
/******************************************************************************/
/** @file txtrtool.cpp
 *     Textures Tool - test program.
 * @par Purpose:
 *     Allows to read DK2 Testures (at least it should, at some point, allow).
 * @par Comment:
 *     None.
 * @author   Tomasz Lis
 * @date     01 Oct 2009 - 05 Oct 2009
 * @par  Copying and copyrights:
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 */
/******************************************************************************/
#include <cstdlib>
#include <iostream>
#include "engine_surfaces.h"

using namespace std;

struct CEngineSurfaceBase *read_texture_file(char *fname)
{
  long width, height, line_len;
  struct CEngineSurfaceBase *esurf;
  void *buf;
  long buf_len;
  FILE *texture_file;
  texture_file = fopen(fname,"r");
  width = -1;
  height = -1;
  line_len = -1;
  fread(&width, 4, 1, texture_file);
  fread(&height, 4, 1, texture_file);
  fread(&line_len, 4, 1, texture_file);
  esurf = new CEngineCompressedSurface(width, height, line_len);
  buf_len = 0;
  buf = esurf->get_data_buffer(&buf_len);
  fread(buf, buf_len, 1, texture_file);
  fclose(texture_file);
  return esurf;
}


int main(int argc, char *argv[])
{
  struct CEngineSurfaceBase *csurf;
  struct CEngineSurfaceBase *usurf;
  graphics_params->set_color_params(0xFF000000u, 0x00FF0000u, 0x0000FF00u, 0x000000FFu, 32);
  csurf = read_texture_file("3dMap_middle_left_SELECTEDMM0");
//TODO
//  usurf = new CEngineSurface();
//  csurf->put_image(usurf, 0, 0);
// Now write the surface on disk, somehow
  system("PAUSE");
  return EXIT_SUCCESS;
}
